///////////////////////////////////////////
//
// file:  GETV.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


MIX_word GETV(  )
{
   int a = INST.A( );
   int f = INST.F( );
   int fetched_byte  = 0;
   int i = INST.I( );
   int L = 0;
   int R = 0;
   int retval_byte = 5;

   MIX_word retval;

   switch( i )
   {
      case 1:
         a += I1REG.A( );
         break;

      case 2:
         a += I2REG.A( );
         break;

      case 3:
         a += I3REG.A( );
         break;

      case 4:
         a += I4REG.A( );
         break;

      case 5:
         a += I5REG.A( );
         break;

      case 6:
         a += I6REG.A( );
         break;

      default:
         break;
   }

   L = f >> 3;
   R = f & 7;

   while( R >= L )
   {
      if( R == 5 )
      {
         if( a >= 0 )
            fetched_byte = MEMORY[a].Byte_5( );
         else
            fetched_byte = cs_MEMORY[-a].Byte_5( );
      }

      if( R == 4 )
      {
         if( a >= 0 )
            fetched_byte = MEMORY[a].Byte_4( );
         else
            fetched_byte = cs_MEMORY[-a].Byte_4( );
      }

      if( R == 3 )
      {
         if( a >= 0 )
            fetched_byte = MEMORY[a].Byte_3( );
         else
            fetched_byte = cs_MEMORY[-a].Byte_3( );
      }

      if( R == 2 )
      {
         if( a >= 0 )
            fetched_byte = MEMORY[a].Byte_2( );
         else
            fetched_byte = cs_MEMORY[-a].Byte_2( );
      }

      if( R == 1 )
      {
         if( a >= 0 )
            fetched_byte = MEMORY[a].Byte_1( );
         else
            fetched_byte = cs_MEMORY[-a].Byte_1( );
      }

      if( R == 0 )
      {
         if( a >= 0 )
            fetched_byte = MEMORY[a].Byte_0( );
         else
            fetched_byte = cs_MEMORY[-a].Byte_0( );
      }

      if( retval_byte == 5 )
         retval.Byte_5( fetched_byte );

      if( retval_byte == 4 )
         retval.Byte_4( fetched_byte );

      if( retval_byte == 3 )
         retval.Byte_3( fetched_byte );

      if( retval_byte == 2 )
         retval.Byte_2( fetched_byte );

      if( retval_byte == 1 )
         retval.Byte_1( fetched_byte );

      if( retval_byte == 0 )
         retval.Byte_0( fetched_byte );

      retval_byte--;
      R--;
   }

   return retval;
}
