///////////////////////////////////////////
//
// file:  INC.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


void INC( )
{
   int f = INST.F( );
   int m = INST.M( );
   int opcode = INST.C( );
   int reg = 0;

   switch( opcode )
   {
      case 48:
         switch( f )
         {
            case 0:
               reg = (AREG.Byte_1( ) << 24)
                     + (AREG.Byte_2( ) << 18)
                     + (AREG.Byte_3( ) << 12)
                     + (AREG.Byte_4( ) << 6)
                     + AREG.Byte_5( );

               if( AREG.Byte_0( ) )
                  reg = -reg;

               reg += m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  AREG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  AREG.Byte_0( 0 );

               AREG.Byte_1( (reg >> 24) & 0x3F );
               AREG.Byte_2( (reg >> 18) & 0x3F );
               AREG.Byte_3( (reg >> 12) & 0x3F );
               AREG.Byte_4( (reg >> 6) & 0x3F );
               AREG.Byte_5( reg & 0x3F );
               break;

            case 1:
               reg = (AREG.Byte_1( ) << 24)
                     + (AREG.Byte_2( ) << 18)
                     + (AREG.Byte_3( ) << 12)
                     + (AREG.Byte_4( ) << 6)
                     + AREG.Byte_5( );

               if( AREG.Byte_0( ) )
                  reg = -reg;

               reg -= m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  AREG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  AREG.Byte_0( 0 );

               AREG.Byte_1( (reg >> 24) & 0x3F );
               AREG.Byte_2( (reg >> 18) & 0x3F );
               AREG.Byte_3( (reg >> 12) & 0x3F );
               AREG.Byte_4( (reg >> 6) & 0x3F );
               AREG.Byte_5( reg & 0x3F );
               break;

            case 2:
               if( m < 0 )
               {
                  AREG.Byte_0( 1 );
                  m = -m;
               }
               else
                  AREG.Byte_0( 0 );

               AREG.Byte_1( (m >> 24) & 0x3F );
               AREG.Byte_2( (m >> 18) & 0x3F );
               AREG.Byte_3( (m >> 12) & 0x3F );
               AREG.Byte_4( (m >> 6) & 0x3F );
               AREG.Byte_5( m & 0x3F );
               break;

            case 3:
               m = -m;

               if( m < 0 )
               {
                  AREG.Byte_0( 1 );
                  m = -m;
               }
               else
                  AREG.Byte_0( 0 );

               AREG.Byte_1( (m >> 24) & 0x3F );
               AREG.Byte_2( (m >> 18) & 0x3F );
               AREG.Byte_3( (m >> 12) & 0x3F );
               AREG.Byte_4( (m >> 6) & 0x3F );
               AREG.Byte_5( m & 0x3F );
               break;

            default:
               break;
         }
         break;

      case 49:
         switch( f )
         {
            case 0:
               reg = (I1REG.Byte_1( ) << 24)
                     + (I1REG.Byte_2( ) << 18)
                     + (I1REG.Byte_3( ) << 12)
                     + (I1REG.Byte_4( ) << 6)
                     + I1REG.Byte_5( );

               if( I1REG.Byte_0( ) )
                  reg = -reg;

               reg += m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I1REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I1REG.Byte_0( 0 );

               I1REG.Byte_4( (reg >> 6) & 0x3F );
               I1REG.Byte_5( reg & 0x3F );
               break;

            case 1:
               reg = (I1REG.Byte_1( ) << 24)
                     + (I1REG.Byte_2( ) << 18)
                     + (I1REG.Byte_3( ) << 12)
                     + (I1REG.Byte_4( ) << 6)
                     + I1REG.Byte_5( );

               if( I1REG.Byte_0( ) )
                  reg = -reg;

               reg -= m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I1REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I1REG.Byte_0( 0 );

               I1REG.Byte_4( (reg >> 6) & 0x3F );
               I1REG.Byte_5( reg & 0x3F );
               break;

            case 2:
               if( m < 0 )
               {
                  I1REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I1REG.Byte_0( 0 );

               I1REG.Byte_4( (m >> 6) & 0x3F );
               I1REG.Byte_5( m & 0x3F );
               break;

            case 3:
               m = -m;

               if( m < 0 )
               {
                  I1REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I1REG.Byte_0( 0 );

               I1REG.Byte_4( (m >> 6) & 0x3F );
               I1REG.Byte_5( m & 0x3F );
               break;

            default:
               break;
         }
         break;

      case 50:
         switch( f )
         {
            case 0:
               reg = (I2REG.Byte_1( ) << 24)
                     + (I2REG.Byte_2( ) << 18)
                     + (I2REG.Byte_3( ) << 12)
                     + (I2REG.Byte_4( ) << 6)
                     + I2REG.Byte_5( );

               if( I2REG.Byte_0( ) )
                  reg = -reg;

               reg += m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I2REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I2REG.Byte_0( 0 );

               I2REG.Byte_4( (reg >> 6) & 0x3F );
               I2REG.Byte_5( reg & 0x3F );
               break;

            case 1:
               reg = (I2REG.Byte_1( ) << 24)
                     + (I2REG.Byte_2( ) << 18)
                     + (I2REG.Byte_3( ) << 12)
                     + (I2REG.Byte_4( ) << 6)
                     + I2REG.Byte_5( );

               if( I2REG.Byte_0( ) )
                  reg = -reg;

               reg -= m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I2REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I2REG.Byte_0( 0 );

               I2REG.Byte_4( (reg >> 6) & 0x3F );
               I2REG.Byte_5( reg & 0x3F );
               break;

            case 2:
               if( m < 0 )
               {
                  I2REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I2REG.Byte_0( 0 );

               I2REG.Byte_4( (m >> 6) & 0x3F );
               I2REG.Byte_5( m & 0x3F );
               break;

            case 3:
               m = -m;

               if( m < 0 )
               {
                  I2REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I2REG.Byte_0( 0 );

               I2REG.Byte_4( (m >> 6) & 0x3F );
               I2REG.Byte_5( m & 0x3F );
               break;

            default:
               break;
         }
         break;

      case 51:
         switch( f )
         {
            case 0:
               reg = (I3REG.Byte_1( ) << 24)
                     + (I3REG.Byte_2( ) << 18)
                     + (I3REG.Byte_3( ) << 12)
                     + (I3REG.Byte_4( ) << 6)
                     + I3REG.Byte_5( );

               if( I3REG.Byte_0( ) )
                  reg = -reg;

               reg += m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I3REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I3REG.Byte_0( 0 );

               I3REG.Byte_4( (reg >> 6) & 0x3F );
               I3REG.Byte_5( reg & 0x3F );
               break;

            case 1:
               reg = (I3REG.Byte_1( ) << 24)
                     + (I3REG.Byte_2( ) << 18)
                     + (I3REG.Byte_3( ) << 12)
                     + (I3REG.Byte_4( ) << 6)
                     + I3REG.Byte_5( );

               if( I3REG.Byte_0( ) )
                  reg = -reg;

               reg -= m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I3REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I3REG.Byte_0( 0 );

               I3REG.Byte_4( (reg >> 6) & 0x3F );
               I3REG.Byte_5( reg & 0x3F );
               break;

            case 2:
               if( m < 0 )
               {
                  I3REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I3REG.Byte_0( 0 );

               I3REG.Byte_4( (m >> 6) & 0x3F );
               I3REG.Byte_5( m & 0x3F );
               break;

            case 3:
               m = -m;

               if( m < 0 )
               {
                  I3REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I3REG.Byte_0( 0 );

               I3REG.Byte_4( (m >> 6) & 0x3F );
               I3REG.Byte_5( m & 0x3F );
               break;

            default:
               break;
         }
         break;

      case 52:
         switch( f )
         {
            case 0:
               reg = (I4REG.Byte_1( ) << 24)
                     + (I4REG.Byte_2( ) << 18)
                     + (I4REG.Byte_3( ) << 12)
                     + (I4REG.Byte_4( ) << 6)
                     + I4REG.Byte_5( );

               if( I4REG.Byte_0( ) )
                  reg = -reg;

               reg += m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I4REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I4REG.Byte_0( 0 );

               I4REG.Byte_4( (reg >> 6) & 0x3F );
               I4REG.Byte_5( reg & 0x3F );
               break;

            case 1:
               reg = (I4REG.Byte_1( ) << 24)
                     + (I4REG.Byte_2( ) << 18)
                     + (I4REG.Byte_3( ) << 12)
                     + (I4REG.Byte_4( ) << 6)
                     + I4REG.Byte_5( );

               if( I4REG.Byte_0( ) )
                  reg = -reg;

               reg -= m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I4REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I4REG.Byte_0( 0 );

               I4REG.Byte_4( (reg >> 6) & 0x3F );
               I4REG.Byte_5( reg & 0x3F );
               break;

            case 2:
               if( m < 0 )
               {
                  I4REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I4REG.Byte_0( 0 );

               I4REG.Byte_4( (m >> 6) & 0x3F );
               I4REG.Byte_5( m & 0x3F );
               break;

            case 3:
               m = -m;

               if( m < 0 )
               {
                  I4REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I4REG.Byte_0( 0 );

               I4REG.Byte_4( (m >> 6) & 0x3F );
               I4REG.Byte_5( m & 0x3F );
               break;

            default:
               break;
         }
         break;

      case 53:
         switch( f )
         {
            case 0:
               reg = (I5REG.Byte_1( ) << 24)
                     + (I5REG.Byte_2( ) << 18)
                     + (I5REG.Byte_3( ) << 12)
                     + (I5REG.Byte_4( ) << 6)
                     + I5REG.Byte_5( );

               if( I5REG.Byte_0( ) )
                  reg = -reg;

               reg += m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I5REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I5REG.Byte_0( 0 );

               I5REG.Byte_4( (reg >> 6) & 0x3F );
               I5REG.Byte_5( reg & 0x3F );
               break;

            case 1:
               reg = (I5REG.Byte_1( ) << 24)
                     + (I5REG.Byte_2( ) << 18)
                     + (I5REG.Byte_3( ) << 12)
                     + (I5REG.Byte_4( ) << 6)
                     + I5REG.Byte_5( );

               if( I5REG.Byte_0( ) )
                  reg = -reg;

               reg -= m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I5REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I5REG.Byte_0( 0 );

               I5REG.Byte_4( (reg >> 6) & 0x3F );
               I5REG.Byte_5( reg & 0x3F );
               break;

            case 2:
               if( m < 0 )
               {
                  I5REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I5REG.Byte_0( 0 );

               I5REG.Byte_4( (m >> 6) & 0x3F );
               I5REG.Byte_5( m & 0x3F );
               break;

            case 3:
               m = -m;

               if( m < 0 )
               {
                  I5REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I5REG.Byte_0( 0 );

               I5REG.Byte_4( (m >> 6) & 0x3F );
               I5REG.Byte_5( m & 0x3F );
               break;

            default:
               break;
         }
         break;

      case 54:
         switch( f )
         {
            case 0:
               reg = (I6REG.Byte_1( ) << 24)
                     + (I6REG.Byte_2( ) << 18)
                     + (I6REG.Byte_3( ) << 12)
                     + (I6REG.Byte_4( ) << 6)
                     + I6REG.Byte_5( );

               if( I6REG.Byte_0( ) )
                  reg = -reg;

               reg += m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I6REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I6REG.Byte_0( 0 );

               I6REG.Byte_4( (reg >> 6) & 0x3F );
               I6REG.Byte_5( reg & 0x3F );
               break;

            case 1:
               reg = (I6REG.Byte_1( ) << 24)
                     + (I6REG.Byte_2( ) << 18)
                     + (I6REG.Byte_3( ) << 12)
                     + (I6REG.Byte_4( ) << 6)
                     + I6REG.Byte_5( );

               if( I6REG.Byte_0( ) )
                  reg = -reg;

               reg -= m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  I6REG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  I6REG.Byte_0( 0 );

               I6REG.Byte_4( (reg >> 6) & 0x3F );
               I6REG.Byte_5( reg & 0x3F );
               break;

            case 2:
               if( m < 0 )
               {
                  I6REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I6REG.Byte_0( 0 );

               I6REG.Byte_4( (m >> 6) & 0x3F );
               I6REG.Byte_5( m & 0x3F );
               break;

            case 3:
               m = -m;

               if( m < 0 )
               {
                  I6REG.Byte_0( 1 );
                  m = -m;
               }
               else
                  I6REG.Byte_0( 0 );

               I6REG.Byte_4( (m >> 6) & 0x3F );
               I6REG.Byte_5( m & 0x3F );
               break;

            default:
               break;
         }
         break;

      case 55:
         switch( f )
         {
            case 0:
               reg = (XREG.Byte_1( ) << 24)
                     + (XREG.Byte_2( ) << 18)
                     + (XREG.Byte_3( ) << 12)
                     + (XREG.Byte_4( ) << 6)
                     + XREG.Byte_5( );

               if( XREG.Byte_0( ) )
                  reg = -reg;

               reg += m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  XREG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  XREG.Byte_0( 0 );

               XREG.Byte_1( (reg >> 24) & 0x3F );
               XREG.Byte_2( (reg >> 18) & 0x3F );
               XREG.Byte_3( (reg >> 12) & 0x3F );
               XREG.Byte_4( (reg >> 6) & 0x3F );
               XREG.Byte_5( reg & 0x3F );
               break;

            case 1:
               reg = (XREG.Byte_1( ) << 24)
                     + (XREG.Byte_2( ) << 18)
                     + (XREG.Byte_3( ) << 12)
                     + (XREG.Byte_4( ) << 6)
                     + XREG.Byte_5( );

               if( XREG.Byte_0( ) )
                  reg = -reg;

               reg -= m;

               if( reg > 1073741823 )
               {
                  reg &= 0x3FFFFFF;
                  OVTOG.Byte_5( 1 );
               }

               if( reg < 0 )
               {
                  XREG.Byte_0( 1 );
                  reg = -reg;
               }
               else
                  XREG.Byte_0( 0 );

               XREG.Byte_1( (reg >> 24) & 0x3F );
               XREG.Byte_2( (reg >> 18) & 0x3F );
               XREG.Byte_3( (reg >> 12) & 0x3F );
               XREG.Byte_4( (reg >> 6) & 0x3F );
               XREG.Byte_5( reg & 0x3F );
               break;

            case 2:
               if( m < 0 )
               {
                  XREG.Byte_0( 1 );
                  m = -m;
               }
               else
                  XREG.Byte_0( 0 );

               XREG.Byte_1( (m >> 24) & 0x3F );
               XREG.Byte_2( (m >> 18) & 0x3F );
               XREG.Byte_3( (m >> 12) & 0x3F );
               XREG.Byte_4( (m >> 6) & 0x3F );
               XREG.Byte_5( m & 0x3F );
               break;

            case 3:
               m = -m;

               if( m < 0 )
               {
                  XREG.Byte_0( 1 );
                  m = -m;
               }
               else
                  XREG.Byte_0( 0 );

               XREG.Byte_1( (m >> 24) & 0x3F );
               XREG.Byte_2( (m >> 18) & 0x3F );
               XREG.Byte_3( (m >> 12) & 0x3F );
               XREG.Byte_4( (m >> 6) & 0x3F );
               XREG.Byte_5( m & 0x3F );
               break;

            default:
               break;
         }
         break;

      default:
         break;
   }

   u_counter++;
}
