///////////////////////////////////////////
//
// file:  MIX.h
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#ifndef MIX_H
#define MIX_H

#include <map>
#include <string>

#include "MIX_word.h"
#include "MIX_Index_register.h"
#include "MIX_Jump_register.h"
#include "MIX_device.h"
#include "MIX_Go_button.h"

extern MIX_word           AREG;
extern MIX_Index_register I1REG;
extern MIX_Index_register I2REG;
extern MIX_Index_register I3REG;
extern MIX_Index_register I4REG;
extern MIX_Index_register I5REG;
extern MIX_Index_register I6REG;
extern MIX_word           XREG;
extern MIX_Jump_register  JREG;
extern MIX_word           ZERO;
extern MIX_word           SIGNA;
extern MIX_word           SIGN1;
extern MIX_word           SIGN2;
extern MIX_word           SIGN3;
extern MIX_word           SIGN4;
extern MIX_word           SIGN5;
extern MIX_word           SIGN6;
extern MIX_word           SIGNX;
extern MIX_word           SIGNJ;
extern MIX_word           SIGNZ;
extern MIX_word           INST;
extern MIX_word           COMPI;
extern MIX_word           OVTOG;
extern MIX_word           CLOCK;

extern MIX_word           MEMORY[4000];
extern MIX_word           cs_MEMORY[4000];

extern int                program_counter;
extern int                u_counter;

extern MIX_device         DEVICES[20];

extern bool               control_state;
extern bool               cycle;
extern bool               interrupts_enabled;


void init_opcodes( map< string, int >& );
void init_f_settings( map< string, int>& );

int ascii_to_MIX( int );
int MIX_to_ascii( int );

MIX_word GETV( );

void enter_control_state( );
void enter_normal_state( );

void NOP( );
void ADD( );
void SUB( );
void MUL( );
void DIV( );
void SPEC( );
void SHIFT( );
void MOVE( );
void LD( );
void ST( );
void JBUS( );
void IOC( );
void IN( );
void OUT( );
void JRED( );
void JCMP( );
void JBIT( );
void INC( );
void CMP( );

#endif
