///////////////////////////////////////////
//
// file:  MIX_Index_register.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX_Index_register.h"


MIX_Index_register::MIX_Index_register( )
{
   _value._int_value = 0;
}


MIX_Index_register::~MIX_Index_register( )
{
}


MIX_Index_register::MIX_Index_register( const MIX_Index_register& IREG )
{
   _value._int_value = IREG._value._int_value;
}


MIX_Index_register& MIX_Index_register::operator=( const MIX_Index_register& IREG )
{
   _value._int_value = IREG._value._int_value;

   return *this;
}


MIX_Index_register::MIX_Index_register( const int number )
{
   if( number < 0 )
   {
      _value._int_value = (-number & 0xFFF);

      Byte_0( 1 );
   }
   else
      _value._int_value = (number & 0xFFF);
}


MIX_Index_register& MIX_Index_register::operator=( const MIX_word& M_w )
{
   Byte_0( M_w.Byte_0( ) );
   Byte_4( M_w.Byte_4( ) );
   Byte_5( M_w.Byte_5( ) );

   return *this;
}


void MIX_Index_register::A( const MIX_word& M_w )
{
   Byte_0( M_w.Byte_0( ) );
   Byte_4( M_w.Byte_1( ) );
   Byte_5( M_w.Byte_2( ) );
}


int MIX_Index_register::A( ) const
{
   int retval = ((Byte_4( ) << 6) | Byte_5( ));

   if( Byte_0( ) )
      retval = -retval;

   return retval;
}
