///////////////////////////////////////////
//
// file:  MIX_device.h
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#ifndef MIX_DEVICE_H
#define MIX_DEVICE_H

#include <File.h>
#include <SupportDefs.h>


// I/O thread functions;
int32 _MIX_device_read( void* );

int32 _MIX_device_write( void* );

int32 _MIX_device_control( void* );


class MIX_device
{
   friend int32 _MIX_device_read( void* );

   friend int32 _MIX_device_write( void* );

   friend int32 _MIX_device_control( void* );

   public:
      MIX_device( );

      virtual ~MIX_device( );

      MIX_device( const MIX_device& );

      MIX_device& operator=( const MIX_device& );

      MIX_device( const int );

      void unit( const int );

      bool busy( ) const;

      bool ready( ) const;

      void read( int );

      void write( int );

      void control( int );

      bool interrupt( ) const;

      void clear_interrupt( );

   private:
      bool _interrupt;
      bool _state;

      int  _unit;
      int  _blocksize;

      BFile* _file;
};


struct MIX_IO_data
{
   MIX_device* device;
   bool        control_state;
   bool        interrupts_enabled;
   int         index;
};

#endif